VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   11040
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11595
   LinkTopic       =   "Form1"
   ScaleHeight     =   11040
   ScaleWidth      =   11595
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   3015
      Left            =   0
      ScaleHeight     =   2955
      ScaleWidth      =   3675
      TabIndex        =   4
      Top             =   480
      Width           =   3735
   End
   Begin VB.ComboBox cboS 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   2640
      List            =   "Form1.frx":001F
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   0
      Width           =   1935
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   2
      Top             =   0
      Width           =   495
   End
   Begin VB.TextBox txtS 
      Height          =   285
      Left            =   360
      TabIndex        =   1
      Text            =   "3.14159265"
      Top             =   0
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "S ="
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' From "Curlicue Fractal" by Eric W. Weisstein.
' From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/CurlicueFractal.html

Option Explicit

Private Sub DrawCurlicue()
Const PI = 3.14159265
Const MY_SCALE As Single = 4

Dim xmax As Single
Dim ymax As Single
Dim s As Single
Dim theta As Single
Dim phi As Single
Dim x As Single
Dim y As Single
Dim i As Integer

    picCanvas.Cls
    picCanvas.ScaleMode = vbPixels
    xmax = picCanvas.ScaleWidth / MY_SCALE
    ymax = picCanvas.ScaleHeight / MY_SCALE
    picCanvas.Scale (-xmax, -ymax)-(xmax, ymax)

    s = CSng(txtS.Text)
    theta = 0
    phi = 0
    x = 0
    y = 0
    picCanvas.CurrentX = x
    picCanvas.CurrentY = y
    For i = 1 To 10000
        x = x + Cos(phi)
        y = y + Sin(phi)
        picCanvas.Line -(x, y)

        phi = SingleMod(theta + phi, 2 * PI)
        theta = SingleMod(theta + 2 * PI * s, 2 * PI)
    Next i
End Sub
' Return value Mod base.
Private Function SingleMod(ByVal value As Single, ByVal base As Single) As Single
Dim divisor As Integer

    divisor = value \ base
    SingleMod = value - divisor * base
End Function


Private Sub cboS_Click()
    Select Case LCase$(cboS.Text)
        Case "pi"
            txtS.Text = 3.14159265
        Case "ln(2)"
            txtS.Text = Format$(Log(2))
        Case "e"
            txtS.Text = Format$(Exp(1))
        Case "sqrt(2)"
            txtS.Text = Format$(Sqr(2))
        Case "sqrt(3)"
            txtS.Text = Format$(Sqr(3))
        Case "sqrt(5)"
            txtS.Text = Format$(Sqr(5))
        Case "lambda"
            txtS.Text = "0.577215664901532860606512090082402431042"
        Case "golden ratio"
            txtS.Text = "1.618033988749894848204586834365638117720"
        Case "feigenbaum"
            txtS.Text = "4.6692016091029906718532038204662016172581855774757686327456513430041343302113147371386897440239480138"
    End Select
    DrawCurlicue
End Sub


Private Sub cmdGo_Click()
    DrawCurlicue
End Sub

Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - picCanvas.Top
    If hgt < 120 Then hgt = 120
    picCanvas.Move 0, picCanvas.Top, ScaleWidth, hgt
End Sub


Private Sub picCanvas_Paint()
    DrawCurlicue
End Sub


Private Sub picCanvas_Resize()
    DrawCurlicue
End Sub


